%Simulates a 2-dimensional Potts model with Glauber dynamics.
%Nearest-neighbor; update each site with rate one.


q=4;                     %number of types
beta=1.5;                %strength of the interaction
L=15; 		         %size of the box
%Times=[0 4 32 250];	 %times when the state is recorded
Times=linspace(0,100,41);

X=ceil(q*rand(L,L));     %iid uniform initial state

begin=clock;

Steps=length(Times); 
tt=1/(L*L);              %duration of one step of the simulation.
time=-tt;                %real time
step=1;
while step<=Steps        %while there is still a time frame to be recorded
 time=time+tt;           %increase real time
 if time>=Times(step)
  Film{1,step}=X;        %record the state
  step=step+1;           %increase counter of next state to be recorded
 end
 site=ceil(L*rand(1,2)); %choose random site
 nn=neigh(site,L);       %coordinates of the 4 neighboring sites
 N=zeros(1,q);           %list of frequencies of types among neighbors
 for n=1:4
  N(X(nn(n,1),nn(n,2)))=N(X(nn(n,1),nn(n,2)))+1;
 end
 prob=zeros(1,q);        %probability to update to a given type
 for type=1:q
  prob(type)=exp(beta*N(type));
 end
 prob=prob/sum(prob);    %normalization
 X(site(1),site(2))=choose(prob);   %new type with law prob
end

elaps=etime(clock,begin);
elaps=elaps/(60*60);
hours=floor(elaps)
elaps=60*(elaps-hours);
minutes=floor(elaps)
seconds=60*(elaps-minutes)

step=1;
Pic=makepic(Film{1,step},q); %Show the initial state
imshow(Pic)
