%Simulates a 2-dimensional nearest-neighbor contact process.

lambda=1.5;              %infection rate
L=25; 		         %size of the box
Times=linspace(0,10,21); %times when the state is recorded

dens=0.01;               %product measure initial state with intensity dens
X=(rand(L,L)<dens);

%mid=ceil(L/2);          %initial state with a single infected site
%X=zeros(L,L);
%X(mid,mid)=1;

begin=clock;

Steps=length(Times); 
tt=1/(L*L*(1+4*lambda)); %duration of one step of the simulation.
p=1/(1+4*lambda);        %probability of recovery
time=-tt;                %real time
step=1;
while step<=Steps        %while there is still a time frame to be recorded
 time=time+tt;           %increase real time
 if time>=Times(step)
  Film{1,step}=2*ones(L,L)-X;  %record the state
  step=step+1;           %increase counter of next state to be recorded
 end
 site=ceil(L*rand(1,2)); %choose random site
 if rand<p
  X(site(1),site(2))=0;  %recovery
 else
  if X(site(1),site(2))==1
   nn=neigh(site,L);     %coordinates of the 4 neighboring sites
   n=ceil(4*rand);       %choose a random neighbor
   X(nn(n,1),nn(n,2))=1; %infect the chosen neighbor
  end
 end
end

elaps=etime(clock,begin);
elaps=elaps/(60*60);
hours=floor(elaps)
elaps=60*(elaps-hours);
minutes=floor(elaps)
seconds=60*(elaps-minutes)

step=1;
q=2;
Pic=makepic(Film{1,step},q); %Show the initial state
imshow(Pic)
