%Calculates the rate of flipping to each of q possible states, based
%on the present state and the number of neighbors in each state.

%Voter model: rate of flipping to state k is fraction of neighbors
%in state k.
function retval=fliprates(x,mm,q)
 retval=mm/sum(mm);
endfunction

%%A stochastic Potts model: flip to color k at rate exp(-beta*not(k)) where 
%%not(k) is number of neighbors that do not have state k
%function retval=fliprates(x,mm,q)
% p=0.4;
% beta=-log(1-p);
% not=sum(mm)-mm;    
% retval=exp(-beta*not);
%endfunction

%%Cycle coordinate model
%%rate 1 move to next state mod(q), moreover
%%change state to k at rate alpha times probability that a randomly
%%chosen pair of neighbors both have the state k.
%function retval=fliprates(x,mm,q)
% alpha=12;
% rates=zeros(1,q);
% y=mod(x,q)+1;
% rates(y)=rates(y)+1;
% for y=1:q
%  rates(y)=rates(y)+alpha*mm(y)*(mm(y)-1)/(2*sum(mm));
% end
% retval=rates;
%endfunction
