%Simulates a 3-dimensional multitype voter model.
%Nearest-neighbor; update each site with rate one, choose random neighbor.

q=25;	                 %number of types
L=10; 		         %size of the box
%Times=[0 4 32 250];	 %times when the state is recorded
Times=linspace(0,100,41);

X=ceil(q*rand(L,L,L));   %iid uniform initial state

begin=clock;

Steps=length(Times); 
tt=1/(L*L*L);            %duration of one step of the simulation.
time=-tt;                %real time
step=1;
while step<=Steps        %while there is still a time frame to be recorded
 time=time+tt;           %increase real time
 if time>=Times(step)
  Film{1,step}=X;        %record the state
  step=step+1;           %increase counter of next state to be recorded
 end
 site=ceil(L*rand(1,3)); %choose random site
 nn=neigh(site,L);       %coordinates of the 6 neighboring sites
 n=ceil(6*rand);         %choose a random neighbor
 X(site(1),site(2),site(3))=X(nn(n,1),nn(n,2),nn(n,3)); %adopt type of
                                                        %chosen neighbor
end

elaps=etime(clock,begin);
elaps=elaps/(60*60);
hours=floor(elaps)
elaps=60*(elaps-hours);
minutes=floor(elaps)
seconds=60*(elaps-minutes)

step=1;
Pic=makepic(Film{1,step},q); %Show the initial state
imshow(Pic)
